<?php
    $total_start_time = microtime(true);
    define('PDEL_ENTRY_SCRIPT' , basename(__FILE__ , '.php'));
    require_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . '_router.php');
    if( ($_SERVER['REQUEST_METHOD'] === 'POST') and (array_key_exists('HTTP_X_REQUESTED_WITH' , $_SERVER) === true) and ($_SERVER['HTTP_X_REQUESTED_WITH'] === 'XMLHttpRequest') ){
        //sleep(1);
        $m_user_level = false;
        switch($_POST['in_radio_mask']){
            case '1':
                //マスキングなし
                $i_decrypt_ptn = 1;
                break;
            case '2':
                //常にマスキング
                $i_decrypt_ptn = 2;
                break;
            default:
                //条件付きマスキング
                switch($_POST['in_radio_level_attr']){
                    case '0':
                        //連続数値昇順型
                        $i_decrypt_ptn = 3;
                        break;
                    case '1':
                        //非連続数値昇順型
                        $i_decrypt_ptn = 4;
                        break;
                    case '2':
                        //文字列昇順型
                        $i_decrypt_ptn = 5;
                        break;
                    case '3':
                        //連続数値降順型
                        $i_decrypt_ptn = 6;
                        break;
                    case '4':
                        //非連続数値降順型
                        $i_decrypt_ptn = 7;
                        break;
                    default:
                        //文字列降順型
                        $i_decrypt_ptn = 8;
                }
                $m_user_level = ctype_digit($_POST['in_level']) ? intval($_POST['in_level']) : $_POST['in_level'];
                if( $m_user_level === 'NA') $m_user_level = false;
                if( $m_user_level === 'nil') $m_user_level = null;
                if( $m_user_level === 'nil_str') $m_user_level = '';
        }
        $s_ini_file = '<PDEL_HOME>conf<DIRECTORY_SEPARATOR>';
        $s_ini_file = ($_POST['nm_opt_recipe'] === '2') ? ($s_ini_file . 'demo') : ($s_ini_file . 'org');
        $s_ini_file = $s_ini_file . '<DIRECTORY_SEPARATOR>ini<DIRECTORY_SEPARATOR>' . $i_decrypt_ptn . '.ini';
        switch($i_decrypt_ptn){
            case 6:
                //パターン6はラッパークラスを使用する
                require_once PDEL_HOME . 'engine'  . DIRECTORY_SEPARATOR . 'DemoWrapper6.php';
                $o_pdel = new DemoWrapper6($s_ini_file);
                break;
            case 8:
                //パターン8はラッパークラスを使用する
                require_once PDEL_HOME . 'engine'  . DIRECTORY_SEPARATOR . 'DemoWrapper8.php';
                $o_pdel = new DemoWrapper8($s_ini_file);
                break;
            default:
        		require_once PDEL_HOME . 'engine'  . DIRECTORY_SEPARATOR . 'Pdel.php';
            	$o_pdel = new Pdel($s_ini_file);
        }
        $input_key = array('a' , 'b' , 'c' , 'd' , 'e' , 'f' , 'g' , 'h' , 'i');
        $a_result = array();
		for($i=0;$i<count($input_key);$i++){
			$before_val = $_POST['in_' . $input_key[$i]];
			$recipe = $_POST['in_recipe_' . $input_key[$i]];
			//復号
            $start_time = microtime(true);
            switch($input_key[$i]){
                case 'h':
                case 'i':
                    $opt = 'key_c=' . $_POST['in_opt_' . $input_key[$i]];
                    break;
                default:
                    $opt = '';
            }
            if( $m_user_level === false ){
                if( $opt === '' ){
                    $a_ret = $o_pdel->decrypt($before_val , $recipe);
                }
                else{
                    $a_ret = $o_pdel->decrypt($before_val , $recipe , $opt);
                }
            }
            else{
                if( $opt === '' ){
                    $a_ret = $o_pdel->decrypt($before_val , $recipe , $m_user_level);
                }
                else{
                    $a_ret = $o_pdel->decrypt($before_val , $recipe , $m_user_level , $opt);
                }
            }
            $end_time = microtime(true);
            $after_val = $a_ret;
            $after_val['result'] = hsc($after_val['result']);
            if( $after_val['status'] === false ) $after_val['detail'] = hsc($after_val['detail']);
            $a_result['in_' . $input_key[$i]] = $after_val;
            $a_result['in_' . $input_key[$i]]['_proc_time'] = sprintf('%.6f ' , ($end_time - $start_time));
		}
        $total_end_time = microtime(true);
        $a_result['total_time'] = sprintf('%.6f ' , ($total_end_time - $total_start_time));
        if( ($_POST['nm_opt_recipe'] === '2') and ($i_decrypt_ptn !== 1) ){
            $s_mask_file = PDEL_HOME . 'conf' . DIRECTORY_SEPARATOR . 'demo' . DIRECTORY_SEPARATOR . 'OPTIONAL' . DIRECTORY_SEPARATOR;
            $s_mask_file = $s_mask_file . $i_decrypt_ptn . '.txt';
            $a_result['mask_rule_file'] = array();
            if( is_normal_file($s_mask_file) === true ){
                $a_result['mask_rule_file']['file_name'] = 'pdel/private_assets/conf/demo/OPTIONAL/' .  $i_decrypt_ptn . '.txt';
                $a_result['mask_rule_file']['contents'] = file_get_contents($s_mask_file);
            }
            else{
                $a_result['mask_rule_file']['file_name'] = '';
            }
            $s_ini_file = PDEL_HOME . 'conf' . DIRECTORY_SEPARATOR . 'demo' . DIRECTORY_SEPARATOR . 'ini' . DIRECTORY_SEPARATOR;
            $s_ini_file = $s_ini_file . $i_decrypt_ptn . '.ini';
            $a_result['pdel_ini_file'] = array();
            if( is_normal_file($s_ini_file) === true ){
                $a_result['pdel_ini_file']['file_name'] = 'pdel/private_assets/conf/demo/ini/' .  $i_decrypt_ptn . '.ini';
                $a_result['pdel_ini_file']['contents'] = file_get_contents($s_ini_file);
            }
            else{
                $a_result['pdel_ini_file']['file_name'] = '';
            }
        }
        if( function_exists('json_encode') === true ){
            $o_json = json_encode($a_result);
        }
        else{
            require_once PDEL_HOME . 'plugins' . DIRECTORY_SEPARATOR . 'JSON.php';
            $o_encoder = new Services_JSON;
            $o_json = $o_encoder->encode($a_result);
        }
        header('Content-Type : application/json');
        echo $o_json;
        exit;
	}
    else{
        if( function_exists('secure_log') === true ) secure_log(basename(__FILE__) . '(' . __LINE__ . ')');
        replyInvalidRequest(3);
    }