<?php
    ini_set('error_reporting' , E_ALL | E_STRICT);
    //コピー環境のHOST名がlocalhostの場合、エラー出力を行うと同時にjQuery等も非圧縮版が読み込まれます。
    ini_set('display_errors' , ($_SERVER['HTTP_HOST'] === 'localhost' ? 1 : 0));
    mb_internal_encoding('UTF-8');
    ini_set('allow_url_fopen' , 0);
    ini_set('allow_url_include' , 0);
    //ディレクトリ構成変更時は、次の二つの定数定義を変更します。(末尾は必ずDIRECTORY_SEPARATORにしてください。)
    define('PDEL_HOME' , dirname(__FILE__) . DIRECTORY_SEPARATOR . 'private_assets' . DIRECTORY_SEPARATOR);
    define('PDEL_LOG_DIR' , dirname(__FILE__) . DIRECTORY_SEPARATOR . 'log' . DIRECTORY_SEPARATOR);
    require_once PDEL_HOME . 'site_generator'  . DIRECTORY_SEPARATOR . '_pdel_site_com.php';
    $auto_stop_file_name = realpath(dirname(__FILE__) . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '.AUTO_STOP_' . PDEL_USE_LANG . '.html');
    if( is_normal_file($auto_stop_file_name) === true ) die(file_get_contents($auto_stop_file_name));
    $manual_stop_file_name = realpath(dirname(__FILE__) . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '.MANUAL_STOP_' . PDEL_USE_LANG . '.html');
    if( is_normal_file($manual_stop_file_name) === true ) die(file_get_contents($manual_stop_file_name));
    //PDELオフィシャルサイトではbrowscapとしてpdel/private_assets/plugins/full_php_browscap.iniを使用
    $browser_chk_file = ini_get('browscap');
    if( (is_normal_file($browser_chk_file) === true) and (array_key_exists('HTTP_USER_AGENT' , $_SERVER) === true ) ){
        $a_browser = get_browser(null , true);
        if( is_array($a_browser) === true ){
        	if( array_key_exists('platform' , $a_browser) === true ) define('PDEL_GUEST_OS' , $a_browser['platform']);
        	if( array_key_exists('browser' , $a_browser) === true ) define('PDEL_GUEST_BROWSER' , $a_browser['browser']);
        	if( array_key_exists('version' , $a_browser) === true ) define('PDEL_GUEST_BROWSER_VER' , $a_browser['version']);
        }
    }
    $access_check_file_name = realpath(dirname(__FILE__) . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '.ope' . DIRECTORY_SEPARATOR . 'access_check.php');
    if( is_normal_file($access_check_file_name) === true ) require_once $access_check_file_name;
    if(array_key_exists('HTTP_USER_AGENT' , $_SERVER) === false ){
        if( function_exists('secure_log') === true ) secure_log(basename(__FILE__) . '(' . __LINE__ . ')');
        die('Invalid request');
    }
    if( stripos($_SERVER['HTTP_USER_AGENT'] , 'wget') !== false ){
        if( function_exists('secure_log') === true ) secure_log(basename(__FILE__) . '(' . __LINE__ . ')');
        die('Invalid request');
    }
    getPdelVersion(realpath(dirname(__FILE__) . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '.release'. DIRECTORY_SEPARATOR . 'notes' . DIRECTORY_SEPARATOR . PDEL_USE_LANG));
    unset($auto_stop_file_name , $manual_stop_file_name , $browser_chk_file , $access_check_file_name);
    if( isset($a_browser) === true ) unset($a_browser);
    if( defined('PDEL_ENTRY_SCRIPT') === false ){
        if( function_exists('secure_log') === true ) secure_log(basename(__FILE__) . '(' . __LINE__ . ')');
        die('Invalid request');
    }