<?php
    define('PDEL_ENTRY_SCRIPT' , basename(__FILE__ , '.php'));
    require_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . '_router.php');
    if( ($_SERVER['REQUEST_METHOD'] === 'GET') and (array_key_exists('HTTP_X_REQUESTED_WITH' , $_SERVER) === true) and ($_SERVER['HTTP_X_REQUESTED_WITH'] === 'XMLHttpRequest') ){
        $a_result = array();
        switch(true){
            case array_key_exists('HTTP_CLIENT_IP' , $_SERVER):
                $a_result['ZFIP'] = $_SERVER['HTTP_CLIENT_IP'] . '<br>' . $_SERVER['REMOTE_ADDR'];
                break;
            case array_key_exists('HTTP_X_FORWARDED_FOR' , $_SERVER):
                $a_result['ZFIP'] = '<span class="pdel_code_red2">' . $_SERVER['HTTP_X_FORWARDED_FOR'] . '</span>';
                break;
            default:
                $a_result['ZFIP'] = $_SERVER['REMOTE_ADDR'];
        }
        $a_result['UA'] = $_SERVER['HTTP_USER_AGENT'];
        $a_result['UA_GUIDE'] = getLocaleResource('{PDEL_i18n_tab4_modal_ua}');

        $a_result['UA_GUIDE'] = str_replace('<PDEL_GUEST_OS>' , (defined('PDEL_GUEST_OS') === true ? PDEL_GUEST_OS : '?') , $a_result['UA_GUIDE']);
        $a_result['UA_GUIDE'] = str_replace('<PDEL_GUEST_BROWSER>' , (defined('PDEL_GUEST_BROWSER') === true ? PDEL_GUEST_BROWSER : '?') , $a_result['UA_GUIDE']);
        $a_result['UA_GUIDE'] = str_replace('<PDEL_GUEST_BROWSER_VER>' , (defined('PDEL_GUEST_BROWSER_VER') === true ? PDEL_GUEST_BROWSER_VER : '?') , $a_result['UA_GUIDE']);
        $a_result['LANG'] = $_SERVER['HTTP_ACCEPT_LANGUAGE'];
        if( array_key_exists('HTTP_ACCEPT_CHARSET' , $_SERVER) === true ) $a_result['LANG'] = $a_result['LANG'] . '<br>' . $_SERVER['HTTP_ACCEPT_CHARSET'];
        if( function_exists('json_encode') === true ){
            $o_json = json_encode($a_result);
        }
        else{
            require_once PDEL_HOME . 'plugins' . DIRECTORY_SEPARATOR . 'JSON.php';
            $o_encoder = new Services_JSON;
            $o_json = $o_encoder->encode($a_result);
        }
        header('Content-Type : application/json');
        echo $o_json;
        exit;
	}
    else{
        if( function_exists('secure_log') === true ) secure_log(basename(__FILE__) . '(' . __LINE__ . ')');
        replyInvalidRequest(3);
    }