function _string_shuffle(s){
    var t = '';
    var len = s.length;
    while(len > 0){
        var p = Math.floor(Math.random() * len);
        t = t + s.charAt(p);
        switch(p){
            case 0:
                if( len === 1 ){
                    s = '';
                    break;
                }
                s = s.substr(1);
                break;
            case (len - 1):
                s = s.substr(0, p);
                break;
            default:
                s = s.substr(0, p) + s.substr(p + 1);
        }
        len = s.length;
    }
    return t;
}
function _gen_variable_map(){
    var s = '.' + '-' + '0123456789' + 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' + 'abcdefghijklmnopqrstuvwxyz';
    var t = _string_shuffle(s);
    $("#pdeltool_v_text").val(t);
    $("#pdeltool_v_text").select();
    return false;
}
function _gen_fixed_map(){
    var s = '.' + '-' + '0123456789' + 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' + 'abcdefghijklmnopqrstuvwxyz';
    var t1 = _string_shuffle(s);
    var loop_breaker = 0;
    while(true){
        var t2 = _string_shuffle(s);
        if( t1 !== t2 ) break;
        loop_breaker++;
        if( loop_breaker === 100 ){
            alert(_PDEL_i18n_msg['loop_err']);
            break;
        }
    }
    var n = '3210321032103210'
    var t3 = _string_shuffle(n);
    $("#pdeltool_f_text").val(t1 + t2 + t3);
    $("#pdeltool_f_text").select();
    return false;
}
function _gen_pwd(){
    var s = '';
    if( $('#pdeltool_pwdchr1').is(':checked') === true ) s = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
    if( $('#pdeltool_pwdchr2').is(':checked') === true ) s = s + 'abcdefghijklmnopqrstuvwxyz';
    if( $('#pdeltool_pwdchr3').is(':checked') === true ) s = s + '0123456789';
    if( $('#pdeltool_pwdchr4').is(':checked') === true ) s = s + "\#\$\+\-\.\/\:\=\?\@\[\]\^\_\`\|";
    //#$+-./:=?@[]^_`|
    var gen_len = parseInt($('#pdel_pwd_len').text());
    var base_len = s.length;
    var loop_breaker = 0;
    while(true){
        var t = '';
        for($i=0;$i<gen_len;$i++){
            var p = Math.floor(Math.random() * base_len);
            t = t + s.charAt(p);
        }
        var chk_result = true;
        if( $('#pdeltool_pwdchr1').is(':checked') === true ){
            var pattern = new RegExp(/[A-Z]+/);
            if( pattern.test(t) === false ) chk_result = false;
        }
        if( (chk_result === true) && ($('#pdeltool_pwdchr2').is(':checked') === true) ){
            var pattern = new RegExp(/[a-z]+/);
            if( pattern.test(t) === false ) chk_result = false;
        }
        if( (chk_result === true) && ($('#pdeltool_pwdchr3').is(':checked') === true) ){
            var pattern = new RegExp(/[0-9]+/);
            if( pattern.test(t) === false ) chk_result = false;
        }
        if( (chk_result === true) && ($('#pdeltool_pwdchr4').is(':checked') === true) ){
            var pattern = new RegExp(/[\#\$\+\-\.\/\:\=\?\@\[\]\^\_\`\|]+/);
            if( pattern.test(t) === false ) chk_result = false;
        }
        if( chk_result === true ) break;
        loop_breaker++;
        if( loop_breaker === 100 ){
            alert(_PDEL_i18n_msg['loop_err']);
            break;
        }
    }
    $("#pdeltool_pwd").val(t);
    $("#pdeltool_pwd").select();
    return false;
}
function _cntl_slider(){
    $("#pdel_slider").slider({
        range :'min',
        value : 8,
        min   : 4,
        max   : 40,
        step  : 1,
        slide : function(e , o) {
            $('#pdel_pwd_len').text(o.value);
        }
    });
}