<?php
    define('PDEL_ENTRY_SCRIPT' , basename(__FILE__ , '.php'));
    require_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . '_router.php');
    if( ($_SERVER["REQUEST_METHOD"] === 'GET') and (function_exists('microtime') === true) and (is_float(microtime(true)) === true) ){
		$html = <<< EOT_HTML
{PDEL-HEADER}
<body data-spy="scroll" data-target=".bs-docs-sidebar">
{PDEL-TOP-NAVI}
{PDEL-SIDE-NAVI}
{PDEL-FOOTER}
{PDEL-JS-LINK}
</body>
</html>
EOT_HTML;
		$html = str_replace('{PDEL-HEADER}' , genHeader() , $html);
        $html = str_replace('{PDEL-TOP-NAVI}' , genTopNavi() , $html);
        $html = str_replace('{PDEL-SIDE-NAVI}' , genSideNavi() , $html);
        $html = str_replace('{PDEL-FOOTER}' , genFooter() , $html);
		$html = str_replace('{PDEL-JS-LINK}' , genJsLink() , $html);
		$html = str_replace('{PDEL_OFFICIAL_HOST}' , PDEL_OFFICIAL_HOST , $html);
		$html = str_replace('{PDEL_USE_BOOTSTRAP_ICON_MENU_OUT}' , PDEL_USE_BOOTSTRAP_ICON_MENU_OUT , $html);
        $php_dir = PDEL_HOME . 'contents'  . DIRECTORY_SEPARATOR . PDEL_USE_LANG  . DIRECTORY_SEPARATOR . PDEL_ENTRY_SCRIPT . DIRECTORY_SEPARATOR . 'php' . DIRECTORY_SEPARATOR;
        $a_php = array('04_01_a' , '04_01_b' , '04_02_a' , '04_02_b' , '04_02_c' , '04_02_d' , '04_03_a' , '04_03_b' , '04_03_c' , '04_03_d');
        for($i=0;$i<count($a_php);$i++){
            $php_file = $php_dir . $a_php[$i] . '.php';
            if( is_normal_file($php_file) === true ){
                $view_content = highlight_file($php_file , true);
                $html = str_replace('{PDEL_PHP_CODE_' . $a_php[$i] . '}' , $view_content , $html);
            }
        }
        $html = getCommonLocaleResource($html);
        echo $html;
    }
    else{
        if( function_exists('secure_log') === true ) secure_log(basename(__FILE__) . '(' . __LINE__ . ')');
        replyInvalidRequest(1);
    }